SG <- function(x)       
{
	while(TRUE)
	{
        branch.length <- range(x)
        x <- x[!is.na(x)]                   # 欠損値を除く
        n <- length(x)                      # 標本サイズ
        t <- abs(range(x)-mean(x))/sd(x)    # 最大のデータと最小のデータの両方について検定統計量を計算する
        p <- n*pt(sqrt((n-2)/((n-1)^2/t^2/n-1)), n-2, lower.tail=FALSE) # P 値も2通り計算される
        result <- list(parameter=c(df=n-2))
        result1 <- structure(c(result,  list(branch.length=branch.length[1], statistic=c(t=t[1]), p.value=p[1])), class="htest")
        result2 <- structure(c(result,  list(branch.length=branch.length[2], statistic=c(t=t[2]), p.value=p[2])), class="htest")
        

        ### Maximum 
        if(result2$p.value < confidence.interval)
        {
#          cat('res2 branch.length ',result2$branch.length,'\n')
#          cat('res2 p ',result2$p.value,'\n')
          dell.value <- c(dell.value, result2$branch.length)
#          cat('dell.value ',dell.value,'\n')
          x <- x[x!= result2$branch.length]
          next
        }
        ### Minimum 
        if(result1$p.value < confidence.interval)
        {
#          cat('res1 branch.length ',result1$branch.length,'\n')
#          cat('res1 p ',result1$p.value,'\n')
          dell.value <- c(dell.value, result1$branch.length)
#          cat('dell.value ',dell.value,'\n')
          x <- x[x!= result1$branch.length]
          next
        }
        else{
          return(list(x=x, dellVal = dell.value))
          break	
        }

      }
      

#        str(result1)
        
#        return(structure(list(result1, result2), class="SG"))
}


###########################
confidence.interval <- 0.05
x <- c(120, 133, 134, 134, 134, 135, 135, 139, 140, 140, 140,
         141, 142, 142, 144, 144, 147, 147, 149, 150, 164, 170)
###########################
dell.value <- NULL

x
resSG <- SG(x)
resSG

